/*

  rz assembly instruction generator
  RZT More efficient assembly generator

  Compiler: Borland TC++ 3.0

  Start: 10 Nov 2001
  Revised: 10 Nov 2001

  Program: Yodthong Rodkaew.

  v1.1

  11 Nov 2201:
    bug fixed: rzt_fetch() rzt_set() rzt_index()
    fix:       data[1]=a; a=data[1]; data[1]=data[1+data[2]]; ?
	       compare & jump, reverse comapre jump
    not support: print_i print_c
*/

#include "compile.h"
#include "rzi.h"
#include "rzth.h"

extern FILE *FO;	   /* compile.c */

typedef struct{ char str[10], len; } icEntry;
extern icEntry icProp[] ; /* iname.h */

extern  int data_based ;  /* data base, global variable */

extern  char zero_reg[10] ;
extern  char addr_reg[10] ;
extern  char sp_reg[10] ;
extern  char bp_reg[10] ;

#define _tab "\t\t\t\t\t"

rztpack rzd[rztpack_max];
int nrztpack ;

int rztsd[1000];
int rztsp;

int usereg;

void rzt_clear() { nrztpack=0; rztsp=0;  usereg=1;}
void rzt_init()  {  rzt_clear(); }
void rzt_done()  { }

void rzt_clearpack(int idx){
  //rzd[idx].container[0]=0;
	rzd[idx].code=0;
	rzd[idx].addr=0;
	rzd[idx].value=0;
	rzd[idx].parent=0;
	rzd[idx].nchild=0;
}

void rztpush(int idx) {
//     fprintf(FO," ;; push %s %d\n",	  icProp[rzd[idx].code].str,rzd[idx].value );
     if (rztsp>1000-1) {fprintf(FO,"PUSH ERR!!\n"); return ;}
	 rztsd[rztsp++]=idx;
}

int rztpop() {
//     fprintf(FO," ;; pop %s %d\n", 	  icProp[rzd[rztsd[rztsp-1]].code].str,rzd[rztsd[rztsp-1]].value );
     if (rztsp<0) {fprintf(FO,"POP ERR!!\n"); return 1;}
	 return (rztsd[--rztsp]) ;
}

int rzt_addpack(int code,int addr,int value)
{
  if (nrztpack==rztpack_max-1) { fprintf(FO,"ADDPACK OVR ERR!!\n"); return 0 ;}
  nrztpack++;
  rzt_clearpack(nrztpack);
  rzd[nrztpack].code=code;
  rzd[nrztpack].addr=addr;
  rzd[nrztpack].value=value;
  rztpush(nrztpack);

  /* Put addr into reg, global variable can use index mode */
  if (code==_Lvalg)
  {
    ++usereg;
//    fprintf(FO, _tab); fprintf(FO," ;; mov r%d,%d \n",usereg,data_based +rzd[nrztpack].value);
      fprintf(FO, "   ld  r%d  #%d ;; rztaddpack Lvalg\n",usereg,data_based+rzd[nrztpack].value);
  }

  return (nrztpack) ;
}

int rzt_addpackpop1(int code,int addr,int value)
{
  int idx,c1;
//  c1=rztpop();
  idx=rzt_addpack(code,addr,value);
//  rztpop(); //release
  rzd[idx].nchild=1;
//  rzd[idx].child[1]=c1;
  rzd[idx].child[1]=rztsd[rztsp-2];
  return (idx) ;
}

int rzt_addpackpop2(int code,int addr,int value)
{
  int idx,c1,c2;
/*  c2=rztpop();
  c1=rztpop();*/
  idx=rzt_addpack(code,addr,value);
//  rztpop(); //release
  rzd[idx].nchild=2;
/*  rzd[idx].child[1]=c1;
  rzd[idx].child[2]=c2;*/
  rzd[idx].child[1]=rztsd[rztsp-3];
  rzd[idx].child[2]=rztsd[rztsp-2];
  return (idx) ;
}

/*-------------------------------*/
int rz_op(char *s_op, int r1, int r2)
{
//      fprintf(FO, _tab); fprintf(FO," ;; %s r%d, r%d \n",s_op,r1,r2);
      fprintf(FO, "   %s  r%d r%d r%d\n",s_op,r1,r1,r2);
}

/*-------------------------------*/

int rzt_travs(int idx, int isleft)
{
  int r1,r2,j;

    j=rztpop();//flush

 /*   if ((rzd[j].code==_Lvalg) || (rzd[j].code==_Lval))
    {
      rztpush(j);
      return usereg;
    }
   */
    if (rzd[j].code==_Lval)
    {
      rztpush(j);
      return usereg;
    }

  if (rzd[idx].nchild==0)
   {

    usereg++;

    /* ---
       parse tree=R side (Rval, Rvalg),
       no (Lval Lvag) exist
			       --- */
    if (rzd[idx].code==_Lvalg)
    {
      rztpush(j);
      usereg--; // :(
      /*
      fprintf(FO, _tab);    fprintf(FO," ;; mov r%d, [r%d] \n",usereg,usereg);
      fprintf(FO, "   ld  r%d  @r%d  %s \n",usereg,usereg,zero_reg);
      */
	fprintf(FO, _tab);    fprintf(FO," ;; ; ignore \n");
    } else

    if (rzd[idx].code==_Rval)
    {
//      fprintf(FO, _tab);    fprintf(FO," ;; mov r%d, [bp-%d] \n",usereg,rzd[idx].value);
      fprintf(FO, "   ld  r%d  @%d  %s ;; rzt_trav rval\n",usereg,-rzd[idx].value,bp_reg);
    } else
    if (rzd[idx].code==_Rvalg)
    {
//      fprintf(FO, _tab);    fprintf(FO," ;; mov r%d, [%d] \n",usereg,data_based +rzd[idx].value);
      fprintf(FO, "   ld  r%d  @%d  %s ;; rzt_trav rvalg\n",usereg,data_based +rzd[idx].value,zero_reg);
    } else
    { /* immediate */
//      fprintf(FO, _tab);    fprintf(FO," ;; mov r%d, %d \n",usereg,rzd[idx].value);
      fprintf(FO, "   ld  r%d  #%d ;; rzt_trav #n\n",usereg,rzd[idx].value);
    }
    return( usereg );
   }

  if (rzd[idx].nchild>0)
   {

    if (rzd[idx].nchild==1)
    {
      r1=rzt_travs(rzd[idx].child[1],1) ;
    }
    if (rzd[idx].nchild==2)
    {
      r1=rzt_travs(rzd[idx].child[1],1) ;
      r2=rzt_travs(rzd[idx].child[2],0) ;
    }

    if (rzd[idx].code==_Add) rz_op("add",r1,r2);
    if (rzd[idx].code==_Sub) rz_op("sub",r1,r2);
    if (rzd[idx].code==_Mul) rz_op("mul",r1,r2);
    if (rzd[idx].code==_Div) rz_op("div",r1,r2);
    --usereg;
    return( usereg );
   } //----nchild>0
}

int rzt_trav()
{
	int j;

    j=rztpop();//flush
    rztpush(j);

    if (rzd[j].code==_Lvalg) return  0 ;

    rzt_travs(nrztpack,1);
}

/*-------------------------------*/
void rzt_fetch()
{
  int idx,r1,r2;
  r1=usereg; r2=usereg;
  idx=rztpop();

//      fprintf(FO, _tab); fprintf(FO," ;; mov r%d, [r%d] \n",r1,r2);
      fprintf(FO, "   ld   r%d @0  r%d ;; rzt_fetch\n",r1,r2);

}

void rzt_set()
{
  int idx,c1,c2;
//  c1=rztpop(); /* flush */
  idx=rztpop();

  switch (rzd[idx].code) {
    /* only L -side here */
     /* special tip for Lvalg, I set addr into reg, so assign via [reg] */
    case _Lvalg:
    //fprintf(FO, _tab);    fprintf(FO," ;; mov [r%d],r%d \n",usereg-1,usereg);
      fprintf(FO, "   st   @0  r%d  r%d ;; rzt_set Lvalg\n",usereg-1,usereg);

      usereg--;
      break;

     /* for Lval, assign via [bp-idx] */
    case _Lval:
//      fprintf(FO, _tab);    fprintf(FO," ;; mov [bp-%d], r%d \n",rzd[idx].value,usereg);
      fprintf(FO, "   st  @%d  %s  r%d ;; rzt_set lval\n",-rzd[idx].value,bp_reg,usereg);

      break;

    default:
     fprintf(FO," errr?? %s %d mov [%d],r%d \n",
	  icProp[rzd[idx].code].str,
	  rzd[idx].value,
	  rzd[idx].addr,usereg);
	  break;
  }
    usereg--;
}

void rzt_index()
{
  int idx,c1,c2;
//  c1=rztpop();
  idx=rztpop();
  rztpush(idx);
//  idx=rztpop();

 /*--
   index command:
    change value in register that contain Lvalg addr
    L side & Global = Lvalg
    no R side or local can do it ( Rvalg Rval Lval ) not possible here
   ----*/

  switch (rzd[idx].code) {
    case _Lvalg:
    //fprintf(FO," add r%d,r%d \n",usereg-1,usereg); usereg--; break;

      rz_op("add",usereg-1,usereg); usereg--;

    break;

    default:
     fprintf(FO," errr?? %s %d mov [%d],r%d \n",
	  icProp[rzd[idx].code].str,
	  rzd[idx].value,
	  rzd[idx].addr,usereg);
	  break;
  }
}
/*-------------------------------*/
void rzt_comp()
{
  int idx,c1,c2;
  c1=rztpop();
  c2=rztpop();

  idx=c1; usereg++;
    if (rzd[idx].code==_Rval)
    {
//      fprintf(FO, _tab);    fprintf(FO," ;; mov r%d, [bp-%d] \n",usereg,rzd[idx].value);
      fprintf(FO, "   ld  r%d  @%d  %s \n",usereg,-rzd[idx].value,bp_reg);
    } else
    if (rzd[idx].code==_Rvalg)
    {
//      fprintf(FO, _tab);    fprintf(FO," ;; mov r%d, [%d] \n",usereg,data_based +rzd[idx].value);
      fprintf(FO, "   ld  r%d  @%d  %s \n",usereg,data_based +rzd[idx].value,zero_reg);
    } else
    if (rzd[idx].code==_Lit)
    {
//      fprintf(FO, _tab);    fprintf(FO," ;; mov r%d, %d \n",usereg,rzd[idx].value);
      fprintf(FO, "   ld  r%d  #%d \n",usereg,rzd[idx].value);
    }
  idx=c2; usereg++;
    if (rzd[idx].code==_Rval)
    {
//      fprintf(FO, _tab);    fprintf(FO," ;; mov r%d, [bp-%d] \n",usereg,rzd[idx].value);
      fprintf(FO, "   ld  r%d  @%d  %s \n",usereg,-rzd[idx].value,bp_reg);
    } else
    if (rzd[idx].code==_Rvalg)
    {
//      fprintf(FO, _tab);    fprintf(FO," ;; mov r%d, [%d] \n",usereg,data_based +rzd[idx].value);
      fprintf(FO, "   ld  r%d  @%d  %s \n",usereg,data_based +rzd[idx].value,zero_reg);
    } else
    if (rzd[idx].code==_Lit)
    {
//      fprintf(FO, _tab);    fprintf(FO," ;; mov r%d, %d \n",usereg,rzd[idx].value);
      fprintf(FO, "   ld  r%d  #%d \n",usereg,rzd[idx].value);
    }

//      fprintf(FO, _tab);    fprintf(FO," ;; cmp r%d, r%d \n",usereg,usereg-1);
   fprintf(FO, "   sub     %s r%d r%d ;; rzt_comp\n" ,zero_reg,usereg,usereg-1);
  usereg-=2;
}

void rzt_printi()
{
  int idx,c1,c2;
  c1=rztpop();

  idx=c1;
//  usereg++;
    //if (rzd[idx].code==_Rval)
    {
//      fprintf(FO, _tab);    fprintf(FO," ;; call print_i\n");
//      fprintf(FO, "   trap print_i     \n");
    } //else
  usereg--;
}

void rzt_printc()
{
  int idx,c1,c2;
  c1=rztpop();

  idx=c1; usereg++;
    //if (rzd[idx].code==_Rval)
    {
//      fprintf(FO, _tab);    fprintf(FO," ;; call print_c\n");
//      fprintf(FO, "   trap print_c     \n");
    } //else
  usereg--;
}

