/* rzloop */
void rzloop()
{
  int i,idx,loc,ip = 1; /* loc,idx of CS */
  int code, param =1;   /* mnemonic I-code and number of parameter */
  int line , oline ;    /* source line marker */
  int p[20];	/* I-code parameter */
  char oldsrctext[100] = " ";
  char srctext[100] = " "; /* source comment helper */

  /*----------------------------*/
  /* pass1 : check location reference
     set doloc[ addr ] =1 if someone reference the addr
  */
  int doloc[1000];
  for (i=0; i<1000; i++)
    doloc[i] = 0;

  while( ip < CP ) {
    loc = ip;
    line = CSLINE[ip];
    code = CS[ip]; ip++;
    param = icProp[code].len;

    for(i=1,idx=1; i<param; i+=2) {
      p[idx++] = CS[ip]*256 + CS[ip+1];
      ip += 2; }
    switch (code) {
    case _Jmp:
    case _Jz:
    case _Call : doloc[ p[1] ] = 1; break;
    }
  }
  /*----------------------------*/
  ip=1; // reset ip , start again
  /*----------------------------*/
  /* pass2 : generate S2 assembly code
     base on I-code ( I-code to S2 translation )
     right comment is intel-like x386 compatible
  */
  oline=0;

  while( ip < CP ) {
    loc = ip;
    line = CSLINE[ip];
    code = CS[ip]; ip++;       /* get code */
    param = icProp[code].len;  /* get no of param */

    for(i=1,idx=1; i<param; i+=2) {      /* get param */
      p[idx++] = CS[ip]*256 + CS[ip+1];
      ip += 2; }

      /* create comment I-code , line no.: source */
    fprintf(FO, "   ;; ---- %s ", icProp[code].str );
    for(i=1,idx=1; i<param; i+=2)
	fprintf(FO, "%d ", p[idx++] );

    if (oline!=line)
    {
	strcpy(srctext, "");
	fseek(FSRC, 0L, SEEK_SET);
	oline=0;
	while (oline<line)
	{
	  oline++;
	  strcpy(oldsrctext, srctext);
	  fgets(srctext, 100, FSRC);
	}
      //oline = line;
    }
    if (srctext[0]=='{')
    fprintf(FO, "---- %d: %s", line ,oldsrctext); else
    fprintf(FO, "---- %d: %s", line ,srctext);

    //---------------------
    fprintf(FO, "\n");

    /* create label if doloc[loc] ==1 */
    if (doloc[loc]) {
//	fprintf(FO, _tab);    fprintf(FO, "   ;; - :label_%d \n",loc);
    fprintf(FO, ":label_%d \n",loc);
    }
    //----------------------
    /* generate S2 with information of I-code */
    if ( code  == _Call ) {
	fprintf(FO, _tab);	fprintf(FO, "   ;; - ;; push addr \n");
	rzpush(addr_reg);
//	fprintf(FO, _tab);	fprintf(FO, "   ;; - call label_%d \n",p[1]);
//	fprintf(FO, "   jal     %s,    %d \n" ,addr_reg,p[1]);
	fprintf(FO, "   jal     %s  label_%d \n" ,addr_reg,p[1]);
	fprintf(FO, _tab);	fprintf(FO, "   ;; - ;; pop addr\n");
	rzpop(addr_reg);
    } else
    if ( code  == _Jmp ) {
//	fprintf(FO, _tab);	fprintf(FO, "   ;; - jmp label_%d \n",p[1]);
//	fprintf(FO, "   jmp   always, %d \n" ,p[1]);
	fprintf(FO, "   jmp   always %d \n" ,p[1]);
    } else
    //---------------------
    if ( code  == _Func ) { /* p[1] = npassed parameter, p[2] = nlocal var */
//	fprintf(FO, "   ;- :label_%d \n",loc);
//	fprintf(FO, _tab);	fprintf(FO, "   ;; - ;; push addr \n");
	rzpush(addr_reg);
	rzcreatestackframe( p[2] );
    } else
    if ( code  == _Ret0 ) {
//	rzdestroystackframe();
	rzretzero();
//	fprintf(FO, _tab);	fprintf(FO, "   ;; - ;; pop addr\n");
//	rzpop(addr_reg);
//	fprintf(FO, _tab);	fprintf(FO, "   ;; - ret\n");
	fprintf(FO, "   jr      %s \n",addr_reg);
    } else
    //---------------------
    if ( code  == _Stop ) {
//	fprintf(FO, _tab);	fprintf(FO, "   ;; - hlt\n");
	fprintf(FO, "   trap    stop \n");
    } else
    //---------------------
    switch (code) {
    case _Lit: rz_inst_pushimm( p[1] ); rzt_addi(code, p[1]); break;
    case _Lval : rz_inst_pushbpsubL( p[1] ); rzt_addi(code, p[1]); break;
    case _Lvalg: rz_inst_pushrefL( p[1] ); rzt_addi(code, p[1]); break;
    case _Rval:  rz_inst_pushbpsub( p[1] ); rzt_addi(code, p[1]); break;
    case _Rvalg: rz_inst_pushref( p[1] ); rzt_addi(code, p[1]); break;

    case _Fetch: rz_inst_fetch(); rzt_addi(code, 0); break;
    case _Set:  rz_inst_set();  rzt_addi(code, 0); break;
    case _Index:  rz_inst_index();  rzt_addi(code, 0); break;

    case  _Add : rz_inst_op("add"); rzt_addi(code, 0); break;
    case  _Sub : rz_inst_op("sub"); rzt_addi(code, 0); break;
    case  _Mul : rz_inst_op("mul"); rzt_addi(code, 0); break;
    case  _Div : rz_inst_op("div"); rzt_addi(code, 0); break;

    case  _Jz : rzt_addi(code, rz_code);
		if (rz_code!=0)  rz_c_jump(p[1]);
		 else rz_inst_jx("eq ", "jz ", p[1]); break;

    case _Minus : rz_inst_Uop_Minus(); rzt_addi(code, 0);break;
    case _Not : rz_inst_Uop_not(); rzt_addi(code, 0);break;

    case _And : rz_inst_Lop("and"); rzt_addi(code, 0); break;
    case _Or : rz_inst_Lop("or"); rzt_addi(code, 0); break;

    case _Lt :
    case _Le :
    case _Eq :
    case _Ne :
    case _Ge :
    case _Gt :  rz_inst_comp(); rz_comp_set(code);
		rzt_addi(code, 0); break;

    case _Print : rz_inst_printi(); rzt_addi(code, 0);break;
    case _Printch : rz_inst_printc(); rzt_addi(code, 0);break;

    default:
       // not support, unfinished!
	fprintf(FO, " ;; %s not support! \n",icProp[code].str );
      ;
    }
    //---------------------
    fprintf(FO, "\n");

  }
}

