/* save rzloop2 */
void rzloop3()
{
  int i,idx,loc,ip = 1; /* loc,idx of CS */
  int code, param =1;   /* mnemonic I-code and number of parameter */
  int line , oline ;    /* source line marker */
  int p[20];	/* I-code parameter */
  char oldsrctext[100] = " ";
  char srctext[100] = " "; /* source comment helper */

  /*----------------------------*/
  /* pass1 : check location reference
     set doloc[ addr ] =1 if someone reference the addr
  */
  int doloc[1000];
  for (i=0; i<1000; i++)
    doloc[i] = 0;

  while( ip < CP ) {
    loc = ip;
    line = CSLINE[ip];
    code = CS[ip]; ip++;
    param = icProp[code].len;

    for(i=1,idx=1; i<param; i+=2) {
      p[idx++] = CS[ip]*256 + CS[ip+1];
      ip += 2; }
    switch (code) {
    case _Jmp:
    case _Jz:
    case _Call : doloc[ p[1] ] = 1; break;
    }
  }
  /*----------------------------*/
  ip=1; // reset ip , start again
  /*----------------------------*/
  /* pass2 : generate S2 assembly code
     base on I-code ( I-code to S2 translation )
     right comment is intel-like x386 compatible
  */
  z_init();
  oline=0;

  while( ip < CP ) {
    loc = ip;
    line = CSLINE[ip];
    code = CS[ip]; ip++;       /* get code */
    param = icProp[code].len;  /* get no of param */

    for(i=1,idx=1; i<param; i+=2) {      /* get param */
      p[idx++] = CS[ip]*256 + CS[ip+1];
      ip += 2;
	}

      /* create comment I-code , line no.: source */
    fprintf(FO, "   ;; ---- %s ", icProp[code].str );
    for(i=1,idx=1; i<param; i+=2)
		fprintf(FO, "%d ", p[idx++] );

    if (oline!=line) {
		strcpy(srctext, "");
		fseek(FSRC, 0L, SEEK_SET);
		oline=0;
		while (oline<line){
		  oline++;
		  strcpy(oldsrctext, srctext);
		  fgets(srctext, 100, FSRC);
		}
      //oline = line;
    }
    if (srctext[0]=='{')
    	fprintf(FO, "---- %d: %s", line ,oldsrctext);
	else
    	fprintf(FO, "---- %d: %s", line ,srctext);

    //---------------------
    fprintf(FO, "\n");

    /* create label if doloc[loc] ==1 */
    if (doloc[loc]) {
//		fprintf(FO, _tab);    fprintf(FO, "   ;; - :label_%d \n",loc);
	    fprintf(FO, ":label_%d \n",loc);
    }
    //----------------------
    /* generate S2 with information of I-code */

	switch( code ){
	case _Call :
		rzpush(addr_reg);
		fprintf(FO, "   jal     %s  label_%d \n" ,addr_reg,p[1]);
		rzpop(addr_reg);
	    break;
	case _Jmp:
		fprintf(FO, "   jmp   always  label_%d \n" ,p[1]);
	    break;
	case _Func:  /* p[1] = npassed parameter, p[2] = nlocal var */
	//	rzpush(addr_reg);
		rzcreatestackframe( p[2] );
	    break;
	case _Ret0:
	//	rzdestroystackframe();
		rzretzero();
	//	rzpop(addr_reg);
		fprintf(FO, "   jr      %s \n",addr_reg);
		break;
	case _Stop:
		fprintf(FO, "   trap    stop \n");
	    break;

    case _Lit:
    case _Lval :
    case _Lvalg:
    case _Rval:
    case _Rvalg: idx = rzt_addpack(code,0,p[1]); break;

    case _Fetch: rzt_fetch(); break;
    case _Set:   rzt_trav(); rzt_set(); break;
    case _Index: rzt_trav(); rzt_index(); break;

    case  _Add :
    case  _Sub :
    case  _Mul :
    case  _Div : idx=rzt_addpackpop2(code,0,0); break;

    case  _Jz :
		if (rz_code != 0)
			rz_c_jump(p[1]);
		else
			rz_inst_jx("eq ", "jz ", p[1]);
		break;

    case _Minus :
		rz_inst_Uop_Minus();
		idx=rzt_addpackpop1(code,0,0);
		break;
    case _Not :
		rz_inst_Uop_not();
		idx=rzt_addpackpop1(code,0,0);
		break;

    case _And :
		rz_inst_Lop("and");
		idx = rzt_addpackpop2(code,0,0);
		break;
    case _Or :
		rz_inst_Lop("or");
		idx=rzt_addpackpop2(code,0,0);
		break;

    case _Lt :
    case _Le :
    case _Eq :
    case _Ne :
    case _Ge :
    case _Gt :
		rz_code = code;
		rzt_comp();
		break;

    case _Print : rzt_printi(); break;
    case _Printch : rzt_printc(); break;

    default:
       // not support, unfinished!
		fprintf(FO, " ;; %s not support! \n",icProp[code].str );
    }
  }
}

