/* s2,h */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#define LDA 0		// op code number
#define LDD 1
#define LDX 9
#define LDI 2
#define STA 3
#define STD 4
#define STX 10
#define JMP 5
#define JAL 6
#define JR 11
#define ADDI 7
#define SUBI 8
#define MULI 9
#define DIVI 10
#define ANDI 11
#define ORI 12
#define XORI 13
#define XOP 31
#define ADD 0
#define SUB 1
#define MUL 2
#define DIV 3
#define AND 4
#define OR 5
#define XOR 6
#define SHL 7
#define SHR 8
#define TRAP 12

#define ALWAYS 0	// jump conditions
#define EQ 1
#define NEQ 2
#define LT 3
#define LE 4
#define GE 5
#define GT 6

#define eqs(a,b)  (strcmp(a,b)==0)

/* IR bits */
int IRop(); /* bit 31..27 */
int IRr1(); /* bit 26..22 */
int IRads();/* bit 21..0  */
int IRr2(); /* bit 21..17 */
int IRr3(); /* bit 16..12 */
int IRxop();/* bit 11..0  */
int IRdisp();/* bit 16..0  */

void error(char *s);

